import nl.tue.id.oocsi.*;

OOCSI oocsi;

int onePerson = 0; int lastPerson = 0; 
PImage Trudie, Gerda, Bert, Question; 
int trudieX = 300;
int trudieY = 250;
int trudieW = 250;
int trudieH = trudieW;
int bertX = trudieX+trudieW+100;
int bertY = trudieY;
int bertW = trudieW;
int bertH = trudieH;
int gerdaX = bertX+bertW+100;
int gerdaY = trudieY;
int gerdaW = trudieW;
int gerdaH = trudieH;

boolean overTrudie = false; // initially no one is selected
boolean overBert = false;
boolean overGerda = false;

void setup() {
  size(1550, 800, P2D);
  Trudie = loadImage("Trudie.png");
  Bert = loadImage ("Bert.png");
  Gerda = loadImage ("Gerda.png");
  Question = loadImage("Question.png");

  oocsi = new OOCSI(this, "researcher", "oocsi.id.tue.nl"); //server is set up through which we communicate from computer to computer.
}

void draw () {
  background(0);
  fill (0);
  println(onePerson);

  if (onePerson == 1) { // nu iemand aanwezig
    if (lastPerson == 0) { // eerst niemand aanwezig
      println("Who is this?"); 
    }
    
    image(Trudie, trudieX, trudieY, trudieW, trudieH);
    image(Bert, bertX, bertY, bertW, bertH);
    image(Gerda, gerdaX, gerdaY, gerdaW, gerdaH);
    image (Question, trudieX+50, 75, 842, 114);

    if ((mouseX > trudieX && mouseX < trudieX+trudieW)&&(mouseY > trudieY && mouseY < trudieY+trudieH)) {
      image(Trudie, trudieX-10, trudieY-10, trudieW+20, trudieH+20);
      overTrudie = true; //mouse is on Trudie
    } else if ((mouseX > bertX && mouseX < bertX+bertW)&&(mouseY > bertY && mouseY < bertY+bertH)) {
      image(Bert, bertX-10, bertY-10, bertW+20, bertH+20);
      overBert = true; //mouse is on Bert
    } else if ((mouseX > gerdaX && mouseX < gerdaX+gerdaW)&&(mouseY > gerdaY && mouseY < gerdaY+gerdaH)) {
      image(Gerda, gerdaX-10, gerdaY-10, gerdaW+20, gerdaH+20);
      overGerda = true; //mouse is on Gerda
    }
  }
  lastPerson = onePerson;
}

void handleOOCSIEvent(OOCSIEvent event) {
  // assign the new fill color from the OOCSI event
  onePerson = event.getInt("WhoIsWatchingQuestion", 0); //receives that there is someone watching from other Processing file.
}

void mouseClicked() {  //We need to say who is watching: id 5, 6 or 7.
  if (overTrudie) {
    oocsi.channel("prototype").data("personWatching", 5).send(); //Sends 5 to other computer. 5 stands for the dataset of Trudie
    println("It is Trudie!");
    overTrudie = false;
    onePerson = 0;
  }
  else if (overBert) {
    oocsi.channel("prototype").data("personWatching", 6).send(); //Sends 6 to other computer. 6 stands for the dataset of Bert
    println("It is Bert!");
    overBert = false;
    onePerson = 0;
  }
  else if (overGerda) {
    oocsi.channel("prototype").data("personWatching", 7).send(); //Sends 7 to other computer. 7 stands for the dataset of Gerda
    println("It is Gerda!");
    overGerda = false;
    onePerson = 0;
  }
}